Index: java/main/src/main/java/com/framsticks/core/Path.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Path.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/core/Path.java	(revision 84)
@@ -2,11 +2,12 @@
 
 import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
 import com.framsticks.params.Param;
-import com.framsticks.params.types.CompositeParam;
-import com.framsticks.util.Dispatching;
-import org.apache.log4j.Logger;
-
+import com.framsticks.util.dispatching.Dispatching;
 import java.util.Iterator;
 import java.util.LinkedList;
+import java.util.List;
+
+import org.apache.commons.collections.ListUtils;
 
 /**
@@ -14,155 +15,190 @@
  */
 public class Path {
-    private final static Logger LOGGER = Logger.getLogger(Path.class.getName());
-
-    final LinkedList<Node> nodes = new LinkedList<Node>();
-    String textual;
-    Instance instance;
-
-    protected Object getKnownChild(AccessInterface access, CompositeParam param) {
-        Object child = access.get(param, Object.class);
-        if (child == null) {
-            return null;
-        }
-        return (instance.prepareAccess(param) != null) ? child : null;
-    }
-
-    public Path(Instance instance, String textual) {
-        assert instance.isActive();
-        this.instance = instance;
-        StringBuilder b = new StringBuilder();
-        nodes.add(instance.root);
-        Node current = instance.root;
-        Iterator<String> i = Instance.splitPath(textual);
-        while (i.hasNext() && current.getObject() != null) {
-            AccessInterface access = instance.prepareAccess(current.getParam());
-            if (access == null) {
-                break;
-            }
-            String e = i.next();
-            Param p = access.getParam(e);
-            if (!(p instanceof CompositeParam)) {
-                //entries.add(new Entry());
-                break;
-            }
-            CompositeParam c = (CompositeParam)p;
-            b.append("/").append(e);
-            access.select(current.getObject());
-            current = new Node(c, getKnownChild(access, c));
-            nodes.add(current);
-        }
-        this.textual = (size() == 1) ? "/" : b.toString();
-    }
-
-    protected Path() {
-
-    }
-
-    public Path appendNode(Node node) {
-        assert isResolved();
-        Path result = new Path();
-        result.textual = textual + ((size() == 1) ? "" : "/") + node.getParam().getId();
-        result.instance = instance;
-        result.nodes.addAll(nodes);
-        result.nodes.add(node);
-        return result;
-    }
-
-    public Path appendParam(CompositeParam param) {
-        assert isResolved();
-        return appendNode(new Node(param, null));
-    }
-
-    public Path appendResolution(Object object) {
-        assert !isResolved();
-        Path result = new Path();
-        result.textual = textual;
-        result.instance = instance;
-        result.nodes.addAll(nodes);
-        result.nodes.add(new Node(result.nodes.pollLast().getParam(), object));
-        return result;
-    }
-
-    public final Object getTopObject() {
-        return getTop().getObject();
-    }
-
-    public final Node getTop() {
-        return nodes.getLast();
-    }
-
-    public final Node getUnder() {
-        assert nodes.size() >= 2;
-        return nodes.get(nodes.size() - 2);
-    }
-
-    public final String getTextual() {
-        return textual;
-    }
-
-    public String toString() {
-        return instance + textual + (!isResolved() ? "!" : "");
-    }
-
-    public final int size() {
-        assert Dispatching.isThreadSafe();
-        return nodes.size();
-    }
-
-    public final boolean isResolved() {
-        assert Dispatching.isThreadSafe();
-        return getTop().getObject() != null;
-    }
-
-    public final boolean isResolved(String textual) {
-        assert Dispatching.isThreadSafe();
-        return isTheSame(textual) && isResolved();
-    }
-
-    public final boolean isTheSame(String textual) {
-        assert Dispatching.isThreadSafe();
-        return this.textual.equals(textual);
-    }
-
-    public final Instance getInstance() {
-        assert Dispatching.isThreadSafe();
-        return instance;
-    }
-
-    public Path findResolution() {
-        assert instance.isActive();
-        assert !isResolved();
-        if (size() == 1) {
+	// private final static Logger log = Logger.getLogger(Path.class.getName());
+
+	final LinkedList<Node> nodes = new LinkedList<Node>();
+	String textual;
+	Instance instance;
+
+	protected Object getKnownChild(AccessInterface access, CompositeParam param) {
+		Object child = access.get(param, Object.class);
+		if (child == null) {
+			return null;
+		}
+		return (instance.registry.prepareAccess(param) != null) ? child : null;
+	}
+
+	// public Path constructPath(Instance instance, String textual) {
+	//	assert instance.isActive();
+
+	// }
+
+	Path(Instance instance, String textual) {
+		assert instance.isActive();
+		this.instance = instance;
+
+		nodes.add(instance.root);
+		Node current = instance.root;
+
+		StringBuilder b = new StringBuilder();
+		Iterator<String> i = Instance.splitPath(textual);
+		while (i.hasNext() && current.getObject() != null) {
+			AccessInterface access = instance.registry.prepareAccess(current.getParam());
+			if (access == null) {
+				break;
+			}
+			String e = i.next();
+			Param p = access.getParam(e);
+			if (!(p instanceof CompositeParam)) {
+				//entries.add(new Entry());
+				break;
+			}
+			CompositeParam c = (CompositeParam)p;
+			b.append("/").append(e);
+			access.select(current.getObject());
+			current = new Node(c, getKnownChild(access, c));
+			nodes.add(current);
+		}
+		this.textual = (size() == 1) ? "/" : b.toString();
+	}
+
+	public Path(Instance instance, List<Node> nodes, Node node) {
+		this.instance = instance;
+		StringBuilder b = new StringBuilder();
+		boolean add = false;
+		for (Node n : nodes) {
+			this.nodes.add(n);
+			if (add) {
+				b.append("/").append(n.getParam().getId());
+			}
+			add = true;
+			if (n == node) {
+				break;
+			}
+		}
+		this.textual = (size() == 1) ? "/" : b.toString();
+	}
+
+	protected Path() {
+
+	}
+
+	public Path appendNode(Node node) {
+		assert isResolved();
+		Path result = new Path();
+		result.textual = textual + ((size() == 1) ? "" : "/") + node.getParam().getId();
+		result.instance = instance;
+		result.nodes.addAll(nodes);
+		result.nodes.add(node);
+		return result;
+	}
+
+	public Path appendParam(CompositeParam param) {
+		assert isResolved();
+		return appendNode(new Node(param, null));
+	}
+
+	public Path appendResolution(Object object) {
+		assert !isResolved();
+		Path result = new Path();
+		result.textual = textual;
+		result.instance = instance;
+		result.nodes.addAll(nodes);
+		result.nodes.add(new Node(result.nodes.pollLast().getParam(), object));
+		return result;
+	}
+
+	public final Object getTopObject() {
+		return getTop().getObject();
+	}
+
+	public final Node getTop() {
+		return nodes.getLast();
+	}
+
+	public final Node getUnder() {
+		assert nodes.size() >= 2;
+		return nodes.get(nodes.size() - 2);
+	}
+
+	public final String getTextual() {
+		return textual;
+	}
+
+	public String toString() {
+		return instance + textual + (!isResolved() ? "!" : "");
+	}
+
+	public final int size() {
+		assert Dispatching.isThreadSafe();
+		return nodes.size();
+	}
+
+	public final boolean isResolved() {
+		assert Dispatching.isThreadSafe();
+		return getTop().getObject() != null;
+	}
+
+	public final boolean isResolved(String textual) {
+		assert Dispatching.isThreadSafe();
+		return isTheSame(textual) && isResolved();
+	}
+
+	public final boolean isTheSame(String textual) {
+		assert Dispatching.isThreadSafe();
+		return this.textual.equals(textual);
+	}
+
+	public final Instance getInstance() {
+		assert Dispatching.isThreadSafe();
+		return instance;
+	}
+
+
+	/** Attach resolution at end, if available.
+	 *
+	 * @return Modified path, if resolution was available, this otherwise.
+	 */
+	public Path tryFindResolution() {
+		assert instance.isActive();
+		assert !isResolved();
+		if (size() == 1) {
 			return new Path(instance, "/");//appendResolution(instance.root.object);
-        }
-        Object child = getKnownChild(instance.bindAccess(getUnder()), getTop().getParam());
-        if (child == null) {
-            return this;
-        }
-        return appendResolution(child);
-    }
-
-    public boolean matches(Path p) {
-        assert Dispatching.isThreadSafe();
-        assert instance == p.instance;
-        Iterator<Node> a = nodes.iterator();
-        Iterator<Node> b = p.nodes.iterator();
-        while (a.hasNext() && b.hasNext()) {
-            Node an = a.next();
-            Node bn = b.next();
-            if (an.object != bn.object) {
-                return false;
-            }
-        }
-        return a.hasNext() == b.hasNext();
-    }
-
-    public String getLastElement() {
-        return getTop().getParam().getId();
-    }
-
-    public final boolean isOwner(Instance instance) {
-        return this.instance == instance;
-    }
+		}
+		Object child = getKnownChild(instance.bindAccess(getUnder()), getTop().getParam());
+		if (child == null) {
+			return this;
+		}
+		return appendResolution(child);
+	}
+
+	public boolean matches(Path p) {
+		assert Dispatching.isThreadSafe();
+		assert instance == p.instance;
+		Iterator<Node> a = nodes.iterator();
+		Iterator<Node> b = p.nodes.iterator();
+		while (a.hasNext() && b.hasNext()) {
+			Node an = a.next();
+			Node bn = b.next();
+			if (an.object != bn.object) {
+				return false;
+			}
+		}
+		return a.hasNext() == b.hasNext();
+	}
+
+	public String getLastElement() {
+		return getTop().getParam().getId();
+	}
+
+	public final boolean isOwner(Instance instance) {
+		return this.instance == instance;
+	}
+
+	@SuppressWarnings("unchecked")
+	public
+	List<Node> getNodes() {
+		return ListUtils.unmodifiableList(nodes);
+	}
 }
 
Index: java/main/src/main/java/com/framsticks/core/Program.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Program.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/core/Program.java	(revision 84)
@@ -1,11 +1,10 @@
 package com.framsticks.core;
 
-import com.framsticks.util.Pair;
-import com.framsticks.util.Strings;
+import com.framsticks.util.lang.IterableIterator;
+import com.framsticks.util.lang.Pair;
+import com.framsticks.util.lang.Strings;
 import org.apache.commons.configuration.*;
 import org.apache.log4j.Logger;
 import org.apache.log4j.PropertyConfigurator;
-//import sun.misc.Signal;
-//import sun.misc.SignalHandler;
 
 import java.lang.reflect.Constructor;
@@ -15,112 +14,99 @@
  * @author Piotr Sniegowski
  */
-public class Program extends com.framsticks.util.Thread {
+public class Program extends com.framsticks.util.dispatching.Thread {
 
-    private final static Logger LOGGER = Logger.getLogger(Program.class.getName());
+	private final static Logger log = Logger.getLogger(Program.class.getName());
 
-/*
-    protected SignalHandler signalHandler = new SignalHandler() {
-        @Override
-        public void handle(Signal signal) {
-            LOGGER.info("caught " + signal);
-            Runtime.getRuntime().exit(0);
-        }
-    };
-*/
+	protected Entity entity;
 
-    protected Entity entity;
+	Configuration config;
 
-    Configuration config;
+	public Program(String name) {
+		super(name, java.lang.Thread.currentThread());
+	}
 
+	public static Entity configureEntity(Configuration config) {
+		String typeName = config.getString("class");
+		log.info("configuring instance " + typeName);
+		try {
+			Class<?> type = Class.forName(typeName);
+			Constructor<?> constructor = type.getConstructor();
+			Entity entity = (Entity) constructor.newInstance();
+			return entity;
+		} catch (Exception e) {
+			log.error("failed to instantiate: " + e);
+		}
+		return null;
+	}
 
-    public Program(String name) {
-        super(name, java.lang.Thread.currentThread());
-//        Signal.handle(new Signal("INT"), signalHandler);
-//        Signal.handle(new Signal("TERM"), signalHandler);
-    }
+	protected static void resolve(Configuration config, String prefix) {
+		for (String p : new IterableIterator<String>(prefix == null ? config.getKeys() : config.getKeys(prefix))) {
+			if (p.endsWith(".mount")) {
+				String source = config.getString(p);
+				log.info("mounting " + source + " at " + p);
+				config.clearProperty(p);
+				Configuration mount = config.subset(source);
+				for (String mk : new IterableIterator<String>(mount.getKeys())) {
+					config.addProperty(p.substring(0, p.length() - 6) + "."	+ mk, mount.getProperty(mk));
+				}
+			}
+		}
+	}
 
-    public static Entity configureEntity(Parameters parameters) {
-        String typeName = parameters.getConfig().getString("class");
-        LOGGER.info("configuring instance " + typeName);
-        try {
-            Class type = Class.forName(typeName);
-            Constructor constructor = type.getConstructor(Parameters.class);
-            return (Entity) constructor.newInstance(parameters);
-        } catch (Exception e) {
-            LOGGER.error("failed to instantiate: " + e);
-        }
-        return null;
-    }
-
-    protected static void resolve(Configuration config, String prefix) {
-
-        Iterator i = prefix == null ? config.getKeys() : config.getKeys(prefix);
-        while (i.hasNext()) {
-            String p = (String) i.next();
-            if (p.endsWith(".mount")) {
-                String source = config.getString(p);
-                LOGGER.info("mounting " + source + " at " + p);
-                config.clearProperty(p);
-                Configuration mount = config.subset(source);
-                Iterator mi = mount.getKeys();
-                while (mi.hasNext()) {
-                    String mk = (String) mi.next();
-                    config.addProperty(p.substring(0, p.length() - 6) + "." + mk, mount.getProperty(mk));
-                }
-            }
-        }
-    }
-
-    public void run(String[] args) {
+	public void run(String[] args) {
 
 		PropertyConfigurator.configure(getClass().getResource("/configs/log4j.properties"));
-		LOGGER.debug("started in " + System.getProperty("user.dir"));
-        try {
+		log.debug("started in " + System.getProperty("user.dir"));
+		try {
 			config = new PropertiesConfiguration(getClass().getResource("/configs/framsticks.properties"));
 
-            for (String a : args) {
-                Pair<String, String> p = Strings.splitIntoPair(a, '=', "true");
-                config.setProperty(p.first, p.second);
-            }
+			for (String a : args) {
+				Pair<String, String> p = Strings.splitIntoPair(a, '=', "true");
+				config.setProperty(p.first, p.second);
+			}
 
-            resolve(config, null);
+			resolve(config, null);
 
-            Iterator i = config.getKeys();
-            while (i.hasNext()) {
-                String p = (String) i.next();
-                LOGGER.debug(p + " = " + config.getProperty(p));
-            }
+			Iterator<?> i = config.getKeys();
+			while (i.hasNext()) {
+				String p = (String) i.next();
+				log.debug(p + " = " + config.getProperty(p));
+			}
 
-        } catch (ConfigurationException e) {
-            System.err.print("failed to parse configuration:" + e);
-            return;
-        }
+		} catch (ConfigurationException e) {
+			System.err.print("failed to parse configuration:" + e);
+			return;
+		}
+		Configuration entityConfig = config.subset("com.framsticks.entity");
 
-        entity = configureEntity(new Parameters(config.subset("com.framsticks.entity"), "main", null, new EntityOwner() {
+		entity = configureEntity(entityConfig);
+		entity.setOwner(new EntityOwner() {
 			@Override
 			public void onDone() {
-				LOGGER.info("exiting");
+				log.info("exiting");
 				Runtime.getRuntime().exit(0);
 			}
-		}));
+		});
+		entity.setName("main");
 		try {
-	        entity.configurePublic();
+			entity.configure(entityConfig);
 		} catch (Exception e) {
-			LOGGER.fatal("exception caught during configuration: " + e);
+			log.fatal("exception caught during configuration: " + e);
 		}
-        LOGGER.info("all entities were configured");
-        entity.start();
-    }
+		log.info("all entities were configured");
+		entity.start();
+	}
 
-    public static void main(final String[] args) {
-        final Program program = new Program("program");
-        program.invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                program.run(args);
-            }
-        });
-        program.routine();
-    }
+	public static void main(final String[] args) {
+
+		final Program program = new Program("program");
+		program.invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				program.run(args);
+			}
+		});
+		program.routine();
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java
===================================================================
--- java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 84)
@@ -1,5 +1,6 @@
 package com.framsticks.diagnostics;
 
-import com.framsticks.core.Parameters;
+import org.apache.commons.configuration.Configuration;
+
 import com.framsticks.observers.Endpoint;
 import com.framsticks.observers.Observer;
@@ -10,27 +11,25 @@
 public class Diagnostics extends Observer {
 
-    final Integer dumpsInterval;
-    final String dumpsPath;
-    final String dumpsFormat;
+	Integer dumpsInterval;
+	String dumpsPath;
+	String dumpsFormat;
 
 
-    public Diagnostics(Parameters parameters) {
-        super(parameters);
-        dumpsInterval = config.getInteger("dumps.interval", null);
-        dumpsPath = config.getString("dumps.path", null);
-        dumpsFormat = config.getString("dumps.format", null);
-    }
+	public Diagnostics() {
+	}
 
-    @Override
-    protected void configure() throws Exception {
-
-        super.configure();
-    }
+	@Override
+	public void configure(Configuration config) {
+		super.configure(config);
+		dumpsInterval = config.getInteger("dumps.interval", null);
+		dumpsPath = config.getString("dumps.path", null);
+		dumpsFormat = config.getString("dumps.format", null);
+	}
 
 
-    @Override
-    protected Endpoint createEndpoint() {
-        return new DiagnosticsEndpoint();
-    }
+	@Override
+	protected Endpoint createEndpoint() {
+		return new DiagnosticsEndpoint();
+	}
 
 
Index: java/main/src/main/java/com/framsticks/diagnostics/DiagnosticsEndpoint.java
===================================================================
--- java/main/src/main/java/com/framsticks/diagnostics/DiagnosticsEndpoint.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/diagnostics/DiagnosticsEndpoint.java	(revision 84)
@@ -1,8 +1,7 @@
 package com.framsticks.diagnostics;
 
-import com.framsticks.core.Path;
+import com.framsticks.dumping.PrintWriterSink;
 import com.framsticks.dumping.SaveStream;
 import com.framsticks.observers.Endpoint;
-import com.framsticks.dumping.PrintStreamSink;
 import com.framsticks.remote.RecursiveFetcher;
 import com.framsticks.util.Logging;
@@ -13,5 +12,5 @@
 import java.io.File;
 import java.io.IOException;
-import java.io.PrintStream;
+import java.io.PrintWriter;
 import java.text.SimpleDateFormat;
 import java.util.Date;
@@ -22,64 +21,64 @@
 public class DiagnosticsEndpoint extends Endpoint {
 
-    private final static Logger LOGGER = Logger.getLogger(DiagnosticsEndpoint.class.getName());
+	private final static Logger log = Logger.getLogger(DiagnosticsEndpoint.class.getName());
 
 
-    public DiagnosticsEndpoint() {
-        super();
-    }
+	public DiagnosticsEndpoint() {
+		super();
+	}
 
-    @Override
-    public Diagnostics getObserver() {
-        return (Diagnostics)observer;
-    }
+	@Override
+	public Diagnostics getObserver() {
+		return (Diagnostics)observer;
+	}
 
 
-    @Override
-    protected void configure() {
-        super.configure();
+	@Override
+	public void start() {
+		super.start();
 
-        if (getObserver().dumpsInterval != null) {
-            new PeriodicTask(instance, getObserver().dumpsInterval * 1000) {
-                @Override
-                public void run() {
+		if (getObserver().dumpsInterval != null) {
+			new PeriodicTask(instance, getObserver().dumpsInterval * 1000) {
+				@Override
+				public void run() {
 
-                    LOGGER.info("starting periodic dump");
-                    new RecursiveFetcher(instance, new Path(instance, "/"), new StateFunctor() {
-                        @Override
-                        public void call(Exception e) {
-                            if (Logging.log(LOGGER, "recursively fetch", instance, e)) {
-                                again();
-                                return;
-                            }
-                            LOGGER.info("instance resolved, saving");
-                            try {
-                                final String fileName = getObserver().dumpsPath + "/" + instance + "_" + new SimpleDateFormat(getObserver().dumpsFormat).format(new Date()) + ".param";
-                                File file = new File(fileName);
-                                new SaveStream(new PrintStreamSink(new PrintStream(file)), instance, new Path(instance, "/"), new StateFunctor() {
-                                    @Override
-                                    public void call(Exception e) {
-                                        Logging.log(LOGGER, "periodic dump in " + fileName + " of", DiagnosticsEndpoint.this.instance, e);
-                                        again();
-                                    }
-                                });
-                            } catch (IOException ex) {
-                                LOGGER.info("failed to initiate dump: " + ex);
-                                again();
-                            }
+					log.info("starting periodic dump");
+					new RecursiveFetcher(instance, instance.getRootPath(), new StateFunctor() {
+						@Override
+						public void call(Exception e) {
+							if (Logging.log(log, "recursively fetch", instance, e)) {
+								again();
+								return;
+							}
+							log.info("instance resolved, saving");
+							try {
+								final String fileName = getObserver().dumpsPath + "/" + instance + "_" + new SimpleDateFormat(getObserver().dumpsFormat).format(new Date()) + ".param";
+								File file = new File(fileName);
+								new SaveStream(new PrintWriterSink(new PrintWriter(file)), instance, instance.getRootPath(), new StateFunctor() {
+									@Override
+									public void call(Exception e) {
+										Logging.log(log, "periodic dump in " + fileName + " of", DiagnosticsEndpoint.this.instance, e);
+										again();
+									}
+								});
+							} catch (IOException ex) {
+								log.info("failed to initiate dump: " + ex);
+								again();
+							}
 
-                        }
-                    });
+						}
+					});
 
 
-                }
-            };
-        }
-    }
+				}
+			};
+		}
+	}
 
-    /*
-    @Override
-    public void onChange(Path path) {
-        super.onChange(path);    //To change body of overridden methods use File | Settings | File Templates.
-    }
-    */
+	/*
+	@Override
+	public void onChange(Path path) {
+		super.onChange(path);    //To change body of overridden methods use File | Settings | File Templates.
+	}
+	*/
 }
Index: java/main/src/main/java/com/framsticks/dumping/FileInstance.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/FileInstance.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/dumping/FileInstance.java	(revision 84)
@@ -2,10 +2,9 @@
 
 import com.framsticks.core.LocalInstance;
-import com.framsticks.core.Parameters;
 import com.framsticks.core.Path;
-import com.framsticks.params.FramsClass;
 import com.framsticks.core.Instance;
-import com.framsticks.util.*;
-import com.framsticks.util.UnsupportedOperationException;
+import com.framsticks.util.dispatching.Future;
+
+import org.apache.commons.configuration.Configuration;
 import org.apache.log4j.Logger;
 
@@ -20,41 +19,45 @@
 public class FileInstance extends LocalInstance {
 
-    private static final Logger LOGGER = Logger.getLogger(Instance.class.getName());
-    protected final File file;
+	private static final Logger log = Logger.getLogger(Instance.class.getName());
+	protected File file;
 
-    public FileInstance(Parameters parameters) {
-        super(parameters);
-        file = new File(config.getString("filename"));
-    }
+	public FileInstance() {
+	}
 
-    @Override
-    public void run() {
-        assert isActive();
-        super.run();
-        try {
-            FileReader fileReader = new FileReader(file);
-            LoadStream stream = new LoadStream(new Path(this, "/"), new BufferedReader(fileReader), this, new Future<Path>() {
-                @Override
-                public void result(Path result, Exception e) {
-                    if (e != null) {
-                        LOGGER.error("failed to load file instance " + FileInstance.this + ": " + e);
-                        fireRun(e);
-                        return;
-                    }
-                    LOGGER.info("loaded file instance " + FileInstance.this);
-                    fireRun(null);
-                }
-            });
-            stream.load();
-        } catch (IOException e) {
-            LOGGER.error("io failure: " + e);
-            fireRun(e);
-        }
-    }
+	@Override
+	public void configure(Configuration config) {
+		super.configure(config);
+		file = new File(config.getString("filename"));
+	}
 
-    @Override
-    public String toString() {
-        return "file@" + file.getName();
-    }
+	@Override
+	public void run() {
+		assert isActive();
+		super.run();
+		try {
+			FileReader fileReader = new FileReader(file);
+			LoadStream stream = new LoadStream(this.getRootPath(), new BufferedReader(fileReader), this, new Future<Path>() {
+				@Override
+				public void result(Path result, Exception e) {
+					if (e != null) {
+						log.error("failed to load file instance " + FileInstance.this + ": " + e);
+						fireRun(e);
+						return;
+					}
+					log.info("loaded file instance " + FileInstance.this);
+					fireRun(null);
+				}
+			});
+			stream.load();
+		} catch (IOException e) {
+			log.error("io failure: " + e);
+			fireRun(e);
+		}
+	}
+
+	@Override
+	public String toString() {
+		return "file@" + file.getName();
+	}
 
 
